# schrankwand.py
# Version mit automatischem Erstellen

from grafikfenster import *

from moebelgruppe import Moebelgruppe
from schrank import Schrank

### ---------------------------------------------------
class Schrankwand(Moebelgruppe):
    '''Die Klasse Schrankwand erzeugt Objekte, die aus
    mehreren Schrankobjekten bestehen koennen.
    Begonnen wird mit einer leeren Schrankwand.'''
    def __init__(self,
                 xPos=50,
                 yPos=150,                 
                 winkel=0,
                 farbe="brown",
                 sichtbar=False):
        Moebelgruppe.__init__(self, xPos, yPos, winkel, farbe, sichtbar)
        self.__anzahl=3
        self.__schrankBreite=60
        self.__schrankTiefe=37
        self.ErzeugeSchrankwand()

    def SetzeWerte(self, anzahl=3, schrankBreite=60, schrankTiefe=37):
        self.__anzahl=anzahl
        self.__schrankBreite=schrankBreite
        self.__schrankTiefe=schrankTiefe
        self.ErzeugeSchrankwand()

    def ErzeugeSchrankwand(self):
        '''die Schrankwand wird neu erzeugt'''
        for moebel in []+self.GibAlle(): # echte Kopie
            self.Entferne(moebel)
            del(moebel)
        for i in range(self.__anzahl):
            self.FuegeHinzu(Schrank(i*self.__schrankBreite,0,
                                    self.__schrankBreite,self.__schrankTiefe,0,
                                    self.GibFarbe()))
    
### ---------------------------------------------------
class SchrankwandApp(wx.App):
    def OnInit(self):
        self.fenster = GrafikFenster(None, "Raumplaner-Grafik")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        self.fenster.panel.Refresh()
        ##self.TestAnwendung()
        self.fenster.ZeigeShellFrame()
        #self.fenster.ZeigeFillingFrame()
        return True

    def BildExport(self, dateiname='bild.png'):
        '''exportiert im png- oder jpg-Format'''
        self.fenster.panel.BildExport(dateiname)

    def TestAnwendung1(self):
        global schrankwand
        print('global: schrankwand\nschrankwand mit drei Schränken')
        schrankwand=Schrankwand(sichtbar=True)

    def TestAnwendung2(self):
        print('erst TestAnwendung1 !\nschrankwand mit fünf Schränken')
        schrankwand.SetzeWerte(5)

### ---------------------------------------------------
if __name__ == '__main__':
    app = SchrankwandApp(redirect=False)
    # Parameterwert True, wenn Ausgaben in der Standard E/A angezeigt werden sollen
    app.MainLoop()
